import ru.resource.news.NewsTape;
import ru.resource.news.News;
import ru.resource.news.DateUtil;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.RequestDispatcher;
import java.io.IOException;

public class ServletController extends HttpServlet {
    private NewsTape newsTape = null;

    public void init(ServletConfig aServletConfig) throws ServletException {
        super.init(aServletConfig);
        newsTape = new NewsTape();
    }

    protected void doGet(HttpServletRequest aRequest, HttpServletResponse aResponse) throws ServletException, IOException {
        handle(aRequest, aResponse);
    }

    protected void doPost(HttpServletRequest aRequest, HttpServletResponse aResponse) throws ServletException, IOException {
        handle(aRequest, aResponse);
    }

    private void handle(HttpServletRequest aRequest, HttpServletResponse aResponse) throws ServletException, IOException {
        aRequest.setCharacterEncoding("utf-8");

        String target = aRequest.getRequestURI().substring(aRequest.getContextPath().length());

        if (target.equals("/")) {
            outputPage("index.jsp", aRequest, aResponse);
        } else if ("/add".equals(target)) {
            handleAdd(aRequest, aResponse);
        } else if ("/view".equals(target)) {
            handleView(aRequest, aResponse);
        }
    }

    private void handleAdd(HttpServletRequest aRequest, HttpServletResponse aResponse) throws IOException, ServletException {
        if ((aRequest.getParameter("caption") != null) && (aRequest.getParameter("message") != null)) {
            News news = new News();
            news.setCaption(aRequest.getParameter("caption"));
            news.setMessage(aRequest.getParameter("message"));
            news.setDate(DateUtil.getDate());
            newsTape.addNews(news);
            handleView(aRequest, aResponse);
        } else {
            aRequest.setAttribute("action", "add");
            aRequest.setAttribute("edit.caption", "");
            aRequest.setAttribute("edit.message", "");
            outputPage("edit.jsp", aRequest, aResponse);
        }
    }

    private void handleView(HttpServletRequest aRequest, HttpServletResponse aResponse) throws IOException, ServletException {
        HttpSession session = aRequest.getSession(true);
        session.setAttribute("NewsTape", newsTape);
        outputPage("view.jsp", aRequest, aResponse);
    }

    public void outputPage(String aJSPName, HttpServletRequest aRequest, HttpServletResponse aResponse) throws IOException, ServletException {
        RequestDispatcher dispatcher = aRequest.getRequestDispatcher("/jsps/" + aJSPName);
        dispatcher.forward(aRequest, aResponse);
    }
}
